<template>
  <div class="login-container">
    <img class="bg" :src="bg" alt="" />
    <img class="logo" :src="logo" alt="" />
    <div class="affiche-box" v-if="noticeData.isShow">
      <h4>{{ noticeData.titile }}</h4>
      <p>
        {{ noticeData.content }}
      </p>
      <div class="qrcode">
        <img :src="noticeData.picture" alt="" />
      </div>
    </div>
    <el-form
      :rules="rules"
      ref="loginForm"
      :model="loginForm"
      class="login-form"
      auto-complete="on"
      label-position="left"
    >
      <div class="title-container">
        <h3 class="title">{{ title }}</h3>
      </div>

      <el-form-item prop="username">
        <span class="svg-container">
          <svg-icon icon-class="user" />
        </span>
        <el-input
          ref="username"
          v-model="loginForm.username"
          placeholder="请输入账号"
          name="username"
          type="text"
          tabindex="1"
          auto-complete="on"
        />
      </el-form-item>

      <el-form-item prop="password">
        <span class="svg-container">
          <svg-icon icon-class="password" />
        </span>
        <el-input
          :key="passwordType"
          ref="password"
          v-model="loginForm.password"
          :type="passwordType"
          placeholder="请输入密码"
          name="password"
          tabindex="2"
          auto-complete="on"
          @keyup.enter.native="handleLogin"
        />
        <span class="show-pwd" @click="showPwd">
          <svg-icon
            :icon-class="passwordType === 'password' ? 'eye' : 'eye-open'"
          />
        </span>
      </el-form-item>

      <el-button
        :loading="loading"
        type="primary"
        style="width: 100%; margin-top: 10px; background: #3d22d7"
        @click.native.prevent="handleLogin"
        >登录</el-button
      >
    </el-form>
  </div>
</template>

<script>
import { validUsername } from "@/utils/validate";
const path = require("path");
import { systemNoticeGetNotice } from "@/api/user_manage";
import { getPicture } from "@/api/user";

export default {
  name: "Login",
  data() {
    const validateUsername = (rule, value, callback) => {
      if (!validUsername(value)) {
        callback(new Error("Please enter the correct user name"));
      } else {
        callback();
      }
    };
    const validatePassword = (rule, value, callback) => {
      if (value.length < 6) {
        callback(new Error("The password can not be less than 6 digits"));
      } else {
        callback();
      }
    };
    return {
      loginForm: {
        username: "",
        password: "",
      },
      rules: {
        password: [
          { required: true, message: "请输入密码", trigger: "blur" },
          {
            pattern:
              /^(((?=.*\d)(?=.*[a-z])(?=.*[A-Z]))|((?=.*\d)(?=.*[a-z])(?=.*[~!@#$%^&*]))|((?=.*\d)(?=.*[A-Z])(?=.*[~!@#$%^&*]))|((?=.*[a-z])(?=.*[A-Z])(?=.*[~!@#$%^&*]))|((?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[~!@#$%^&*]))).{10,32}$/,
            message:
              "必须大小写字母、数字、特殊字符,4种组合中至少满足3种，且密码长度在10-32位之间。若无法登录，请联系管理员！",
          },
        ],
      },
      loading: false,
      passwordType: "password",
      redirect: undefined,
      // 公告数据
      noticeData: {},
      title: "防控终端管理平台",
      bg:'',
      logo:'',
    };
  },
  watch: {
    $route: {
      handler: function (route) {
        this.redirect = route.query && route.query.redirect;
      },
      immediate: true,
    },
  },
  created() {
    this.getPicture();
    this.systemNoticeGetNotice();
  },
  methods: {
    // 获取背景
    getPicture() {
      getPicture().then((res) => {
        console.log(res);
        this.title = res.data.title;
        this.bg = res.data.bg;
        this.logo = res.data.logo;
        document.title=res.data.title
        this.changeFavicon(res.data.favicon);
      });
    },
    // 更改favicon.icon
    changeFavicon(link) {
      let $favicon = document.querySelector('link[rel="icon"]');
      if ($favicon !== null) {
        $favicon.href = link;
      } else {
        $favicon = document.createElement("link");
        $favicon.rel = "icon";
        $favicon.href = link;
        document.head.appendChild($favicon);
      }
    },
    // 获取公告栏
    systemNoticeGetNotice() {
      systemNoticeGetNotice().then((res) => {
        this.noticeData = res.data;
      });
    },
    showPwd() {
      if (this.passwordType === "password") {
        this.passwordType = "";
      } else {
        this.passwordType = "password";
      }
      this.$nextTick(() => {
        this.$refs.password.focus();
      });
    },
    handleLogin() {
      this.$refs.loginForm.validate(async(valid) => {
        if (valid) {
          this.loading = true;
          // this.$store
          //   .dispatch("user/login", this.loginForm)
          //   .then(() => {
          //     if (this.$store.getters.role === 1) {
          //       this.$router.push({ path: "/index" });
          //     } else if (this.$store.getters.role === 2) {
          //       this.$router.push({ path: "/index" });
          //     } else if (this.$store.getters.role === 3) {
          //       this.$router.push({ path: "/index" });
          //     } else if (this.$store.getters.role === 4) {
          //       this.$router.push({ path: "/index" });
          //     } else if (this.$store.getters.role === 5) {
          //       this.$router.push({ path: "/index" });
          //     } else if (this.$store.getters.role === 99) {
          //       this.$router.push({ path: "/machine_list/index" });
          //     }
          //     this.loading = false;
          //   })
          //   .catch(() => {
          //     this.loading = false;
          //   });
          try {
            await this.$store.dispatch('user/login', this.loginForm)
            await this.$store.dispatch('user/getInfo')
            if (this.$store.getters.role === 1) {
              this.$router.push({ path: '/index' })
            } else if (this.$store.getters.role === 2) {
              this.$router.push({ path: '/index' })
            } else if (this.$store.getters.role === 3) {
              this.$router.push({ path: '/index' })
            } else if (this.$store.getters.role === 4) {
              this.$router.push({ path: '/index' })
            } else if (this.$store.getters.role === 5) {
              this.$router.push({ path: '/index' })
            } else if (this.$store.getters.role === 99) {
              this.$router.push({ path: '/machine_list/index' })
            }
            this.loading = false
          } catch (e) {
            await this.$store.dispatch('user/resetToken')
            this.loading = false
          }
        } else {
          console.log('error submit!!')
          return false
        }
      })
    }
  }
}
</script>

<style lang="scss">
/* 修复input 背景不协调 和光标变色 */
/* Detail see https://github.com/PanJiaChen/vue-element-admin/pull/927 */

$bg: #283443;
$light_gray: #fff;
$cursor: #fff;

@supports (-webkit-mask: none) and (not (cater-color: $cursor)) {
  .login-container .el-input input {
    color: $cursor;
  }
}

/* reset element-ui css */
.login-container {
  .el-input {
    display: inline-block;
    height: 47px;
    width: 85%;

    input {
      background: transparent;
      border: 0px;
      -webkit-appearance: none;
      border-radius: 0px;
      padding: 12px 5px 12px 15px;
      color: black;
      height: 47px;
      caret-color: black;

      &:-webkit-autofill {
        box-shadow: 0 0 0px 1000px rgb(222,229,246) inset !important;
        -webkit-text-fill-color: #000 !important;
      }
    }
  }

  .el-form-item {
    border: 1px solid rgba(255, 255, 255, 0.1);
    background: rgba(255, 255, 255, 0.8);
    border-radius: 5px;
    color: #454545;
  }
}
</style>

<style lang="scss" scoped>
$bg: #2d3a4b;
$dark_gray: #889aa4;
$light_gray: #eee;

.login-container {
  min-height: 100%;
  width: 100%;
  min-width: 1450px;
  background-color: $bg;
  // background-image: url("http://hanghui.oss-cn-gz-ysgzlt-d01-a.ltops.gzdata.com.cn/log/bg.png");
  // background-repeat: no-repeat;
  // background-size: 100% 100%;
  overflow: hidden;
  display: flex;
  justify-content: center;
  align-items: center;
  position: relative;
  .bg {
    width: 100%;
    height: 100%;
    position: absolute;
  }
  .login-form {
    position: relative;
    width: 550px;
    max-width: 100%;
    padding: 40px 60px;
    margin: 0 auto;
    overflow: hidden;
    background-color: rgba(255, 255, 255, 0.3);
    backdrop-filter: blur(20px);
    border-radius: 15px;
  }

  .tips {
    font-size: 14px;
    color: #fff;
    margin-bottom: 10px;

    span {
      &:first-of-type {
        margin-right: 16px;
      }
    }
  }

  .svg-container {
    padding: 6px 5px 6px 15px;
    color: $dark_gray;
    vertical-align: middle;
    width: 30px;
    display: inline-block;
  }

  .title-container {
    position: relative;

    .title {
      font-size: 30px;
      color: #fff;
      margin: 0px auto 40px auto;
      text-align: center;
      font-weight: bold;
    }
  }

  .show-pwd {
    position: absolute;
    right: 10px;
    top: 7px;
    font-size: 16px;
    color: $dark_gray;
    cursor: pointer;
    user-select: none;
  }

  .logo {
    position: absolute;
    right: 50px;
    top: 50px;
    height: 90px;
  }
}
.el-form-item__error {
  color: red;
}
.affiche-box {
  position: absolute;
  width: 353px;
  // height: 609px;
  right: 15px;
  top: 187px;
  background: rgba(255, 255, 255, 0.2);
  box-shadow: 0px 2px 18px rgba(81, 223, 255, 0.1);
  border-radius: 20px;
  padding: 22px;
  color: #ffffff;
  h4 {
    font-size: 20px;
    font-weight: 500;
    text-align: center;
    margin: 0 0 20px;
  }
  p {
    font-size: 17px;
    font-weight: 400;
    line-height: 181%;
    color: rgba(255, 255, 255, 0.78);
  }
  .qrcode {
    p {
      font-weight: 500;
      margin: 0;
      color: #ffffff;
      line-height: 142%;
      text-align: center;
    }
    img {
      width: 180px;
      // height: 180px;
      display: block;
      margin: 0 auto;
    }
  }
}
</style>
